import java.io.*;
import java.net.*;
import java.util.*;
import netscape.javascript.*;


public class ChatClient implements Runnable
{
	Socket chatSocket = null;
	PrintWriter out = null;
	BufferedReader in = null;
	Client client = null;
	String sep;
	boolean bConnected = false;
	public JSObject win = null;
	
	
	public String strName;
	public String strUserid;
	public String strIcon;
	public String strMaster;
	public String strRoomid;
	
	public WaitRoom waitroom = null;
	public Room room = null;
	
	
	public ChatClient(Client pClient)
	{
		sep = pClient.sep;
		client = pClient;
		win = client.win;
		
		waitroom = new WaitRoom(this);
  		room = new Room(this);
	}
	
	public void connect(String host, int port)
	{
		try
		{
			chatSocket = new Socket(host, port);
			out = new PrintWriter(chatSocket.getOutputStream(), true);
			in = new BufferedReader(new InputStreamReader(chatSocket.getInputStream()));			
		}
		catch (UnknownHostException e)
		{
			//client.ErrorMsg("ȣƮ ̻մϴ");
			System.exit(1);
		}
		catch (IOException e)
		{
			//client.ErrorMsg(" Դϴ");
			System.exit(1);
		}
		
		bConnected = true;
		
		Thread thd;
		thd = new Thread(this);
		thd.start();	
		
		FirstSend();
	}
	
	public void FirstSend()
	{
		send("START", "");
	}
	
	public void send(String pCommand, String pMsg)
	{
		out.println(pCommand + sep + strUserid + sep + strName + sep + strIcon + sep + strRoomid + sep + pMsg + "\n");
	}
	
	public void disconnect()
	{
		if (bConnected == true)
		{
			send("DISCONNECT", "");
		
			try
			{
				out.close();
				in.close();
				chatSocket.close();
			}
			catch (IOException e)
			{			
			}
		
			bConnected = false;
		}
	}	
	
	public void run()
	{
		try
		{
			while(true)
			{
				//RecvProcess(in.readLine());		
				RecvProcess(new StringTokenizer(in.readLine(), sep));		
			}						
		}
		catch (IOException e)
		{
			disconnect();
		}
		
	}
	
	public void RecvProcess(StringTokenizer token)
	{		
		String mode = null;
		String userid = null;
		String name = null;
		String icon = null;		
		
		try
		{
			if (token.hasMoreTokens())
				mode = token.nextToken();
			else
				return;
			
			if (token.hasMoreTokens())
				userid = token.nextToken();
			else
				return;
			
			if (token.hasMoreTokens())
				name = token.nextToken();		
			else
				return;
				
			if (token.hasMoreTokens())
				icon = token.nextToken();		
			else
				return;
		}
		catch(Exception e)
		{
			return;
		}
		
		if (mode.equals("WAITUSER"))
		{
			//   Ʈ ´
			String count = token.nextToken();
			waitroom.RecvList(Integer.parseInt(count), token);
		}
		else if (mode.equals("JOINWAITUSER"))
		{
			// ǿ  
			waitroom.RecvJoin(userid, name, icon, "");
		}
		else if (mode.equals("EXITWAITUSER"))
		{
			// ǿ  
			waitroom.RecvExit(userid, name, icon, "");
		}
		else if (mode.equals("JOINROOMINIT"))
		{
			// 濡   غ ͸ 
			String roomid = token.nextToken();
			String roomname = token.nextToken();
			String master = token.nextToken();
			waitroom.RecvJoinRoomInit(userid, name, icon, roomid, roomname, master);
		}
		else if (mode.equals("JOINUSER"))
		{
			// 濡  
			if (userid.equals(strUserid))
				win.eval("WriteFirstHeader()");
			else
				room.RecvJoin(userid, name, icon, "");
		}
		else if (mode.equals("USER"))
		{
			//  Ʈ ´
			String count = token.nextToken();
			room.RecvList(Integer.parseInt(count), token);
		}
		else if (mode.equals("EXITUSER"))
		{
			// 濡  
			room.RecvExit(userid, name, icon, "");
		}
		else if (mode.equals("EXITROOMINIT"))
		{
			// ڱ ڽ 濡 
			
			win.eval("ExitRoom(\"" + strName + "\", \"" + strIcon + "\")");
			client.SetRoomid("0");
			send("CONNECT", "");
		}
		else if (mode.equals("MSG"))
		{
			String msg = token.nextToken();	
			String fontcolor = token.nextToken();	
			String backcolor = token.nextToken();	
			String fontsize = token.nextToken();	
			String fontname = token.nextToken();	
			String fontbold = token.nextToken();	
			String fontitalic = token.nextToken();	
			String fontunderline = token.nextToken();
			
			msg = client.MakeFontString(msg, fontcolor, fontsize, fontname, fontbold, fontitalic, fontunderline);	
			
			room.RecvMsg(userid, name, icon, msg, backcolor);	
		}
		else if (mode.equals("ROOMLIST"))
		{
			//   Ʈ ´
			String count = token.nextToken();
			waitroom.RecvRoomList(Integer.parseInt(count), token);
		}
		else if (mode.equals("MAKEROOM"))
		{
			waitroom.RecvMakeRoom();
		}
		else if (mode.equals("REMOVEROOM"))
		{
			waitroom.RecvRemoveRoom();
		}
		else if (mode.equals("JOINROOM"))
		{
			waitroom.RecvJoinRoom();
		}
		else if (mode.equals("CHANGENAME"))
		{
			String newname = token.nextToken();	
			String newicon = token.nextToken();	
			room.RecvChangeName(userid, name, icon, newname, newicon);
		}
		else if (mode.equals("INTRODUCE"))
		{
			String msg = token.nextToken();	
			room.RecvIntroduce(msg);
		}
		else if (mode.equals("MUSIC"))
		{
			String msg = token.nextToken();	
			room.RecvMusic(userid, name, icon, msg);
		}
		else if (mode.equals("MEMO"))
		{
			String msg = token.nextToken();	
			waitroom.RecvMemo(userid, name, icon, msg);
		}
		else if (mode.equals("GOOUT"))
		{
			room.RecvGoout();
		}
		else if (mode.equals("FORCE"))
		{
			room.RecvForce(userid, name, icon, "");
		}
		else if (mode.equals("CHANGEMASTER"))
		{
			String toid = token.nextToken();	
			room.RecvChangeMaster(userid, toid);
		}
		else if (mode.equals("ROOMINFO"))
		{
			String roomid = token.nextToken();	
			String roomname = token.nextToken();	
			String roomlimit = token.nextToken();	
			String roomtype = token.nextToken();	
			String roompass = token.nextToken();	
			String roomgroup = token.nextToken();	
			room.RecvRoomInfo(roomid, roomname, roomlimit, roomtype, roompass, roomgroup);
		}
		else if (mode.equals("MASTERROOMINFO"))
		{
			String roomid = token.nextToken();	
			String roomname = token.nextToken();	
			String roomlimit = token.nextToken();	
			String roomtype = token.nextToken();	
			String roompass = token.nextToken();	
			String roomgroup = token.nextToken();	
			
			room.RecvMasterRoomInfo(roomid, roomname, roomlimit, roomtype, roompass, roomgroup);
		}
		else if (mode.equals("CHANGEROOMNAME"))
		{
			String roomname = token.nextToken();	
			room.RecvChangeRoomName(roomname);
		}
		else if (mode.equals("ALERT"))
		{
			String msg = token.nextToken();
			win.eval("alert(\"" + msg + "\")");
		}
		else if (mode.equals("CLOSE"))
		{
			String msg = token.nextToken();
			win.eval("alert(\"" + msg + "\")");
			win.eval("top.close()");
		}
		else if (mode.equals("HEY"))
		{
			send("WHY", "");
		}
		else
		{
			win.eval("alert(\"" + mode + "\")");
		}
	}
}

