import java.util.*;
import java.lang.*;
import netscape.javascript.*;

public class Room
{
	Hashtable users = new Hashtable();	
	JSObject win;
	String sep;
	ChatClient client;
	
	public Room(ChatClient pClient)
	{
		client = pClient;
		
		win = client.win;
		sep = client.sep;
	}
	
	public void RecvJoin(String pUserid, String pName, String pIcon, String pMaster)
	{
		User user = new User(pUserid, pName, pIcon, pMaster);
		users.put(pUserid, user);
		
		win.eval("WriteJoin(\"" + pName + "\", \"" + pIcon + "\")");
		
		WriteList();
	}
	
	public void RecvExit(String pUserid, String pName, String pIcon, String pMaster)
	{
		users.remove(pUserid);
		
		win.eval("WriteExit(\"" + pName + "\", \"" + pIcon + "\")");
		
		WriteList();
	}
	
	public void RecvList(int pCount, StringTokenizer pToken)
	{
		users.clear();
		
		for(int i = 0; i < pCount; i++)
		{
			String id = pToken.nextToken();
			String name = pToken.nextToken();
			String icon = pToken.nextToken();
			String master = pToken.nextToken();
			
			User user = new User(id, name, icon, master);
			users.put(id, user);

		}
		
		WriteList();
	}
	
	public void WriteList()
	{
		win.eval("WriteUserListStart(\"" + users.size() + "\")");
		
		Enumeration e = users.elements();
		
		while (e.hasMoreElements())
		{
			User user = (User)e.nextElement();
			win.eval("WriteUserList(\"" + user.strUserid + "\", \"" + user.strName + "\", \"" + user.strIcon + "\", \"" + user.strMaster + "\")");
			
			if (!user.strUserid.equals(client.strUserid))
				win.eval("WriteSendList(\"" + user.strUserid + "\", \"" + user.strName + "\", \"" + user.strIcon + "\", \"" + user.strMaster + "\")");
		}
		
		win.eval("WriteUserListEnd()");
		
	}
	
	public void RecvMsg(String pUserid, String pName, String pIcon, String pStr, String pBackcolor)
	{				
		if (client.strUserid.equals(pUserid))
		{
			win.eval("WriteSelfMessage(\"" + pIcon + ".gif\", \"" + pName + "\" ,\"" + pStr + "\" ,\"" + pBackcolor + "\")");		
		}
	  	else
	  	{
			win.eval("WriteMessage(\"" + pIcon + ".gif\", \"" + pName + "\" ,\"" + pStr + "\" ,\"" + pBackcolor + "\")");
		}		
	}
	
	public void RecvChangeName(String pUserid, String pName, String pIcon, String pNewname, String pNewicon)
	{
		User user = (User)users.get(pUserid);
		user.strName = pNewname;
		user.strIcon = pNewicon;
		
		win.eval("WriteChangeName(\"" + pName + "\", \"" + pIcon + "\", \"" + pNewname + "\", \"" + pNewicon + "\")");
		
		WriteList();
	}
	
	public void RecvIntroduce(String pMsg)
	{
		win.eval("WriteIntroduce(\"" + pMsg + "\")");
	}
	
	public void RecvMusic(String pUserid, String pName, String pIcon, String pMsg)
	{
		win.eval("WriteMusic(\"" + pName + "\", \"" + pIcon + "\", \"" +  pMsg + "\")");
	}
	
	public void RecvGoout()
	{
		client.send("FORCE", "");
		win.eval("WriteGoout()");
	}
		
	public void RecvForce(String pUserid, String pName, String pIcon, String pMaster)
	{
		users.remove(pUserid);
		
		win.eval("WriteGooutExit(\"" + pName + "\", \"" + pIcon + "\")");
		
		WriteList();
	}
	
	public void RecvChangeMaster(String pFromid, String pToid)
	{
		if (client.strUserid.equals(pToid))
		{
			client.strMaster = "1";
			win.eval("WriteGetMaster()");
		}
		else if (client.strUserid.equals(pFromid))
		{
			client.strMaster = "0";
			win.eval("WriteLostMaster()");
		}
		else
		{
			User user = (User)users.get(pToid);
			
			win.eval("WriteChangeMaster(\"" + user.strName + "\", \"" + user.strIcon + "\")");
		}
		
		WriteList();
	}
	
	public void RecvRoomInfo(String pRoomid, String pRoomname, String pRoomlimit, String pRoomtype, String pRoompass, String pRoomgroup)
	{
		win.eval("WriteRoomInfo(\"" + pRoomid + "\", \"" + pRoomname + "\", \"" + pRoomlimit + "\", \"" + pRoomtype + "\", \"" + pRoompass + "\", \"" +  pRoomgroup + "\")");
	
	}
	
	public void RecvMasterRoomInfo(String pRoomid, String pRoomname, String pRoomlimit, String pRoomtype, String pRoompass, String pRoomgroup)
	{
		win.eval("WriteMasterRoomInfo(\"" + pRoomid + "\", \"" + pRoomname + "\", \"" + pRoomlimit + "\", \"" + pRoomtype + "\", \"" + pRoompass + "\", \"" +  pRoomgroup + "\")");
	}
	
	public void RecvChangeRoomName(String pMsg)
	{
		win.eval("WriteChangeRoomName(\"" + pMsg + "\")");
	}
}