#!/usr/bin/env python
# -*- coding: utf_8 -*-

import string
from GlobalVar import *
from ChatServer import *

class AllUsersList:
	def __init__(self, pSep, pChatServer):
		self.users	= {}
		self.chatserver		= pChatServer
		self.sep	= pSep
		
		self.CONN	= 0
		self.ADDR	= 1
		self.NAME	= 2
		self.ICON	= 3
		self.MASTER	= 4
		self.ROOMID	= 5
		self.ROOMGROUP	= 6
		
		self.NORMAL_VAR	= 0
		self.MASTER_VAR	= 1
		
	def __len__(self):
		return len(self.users)

	def append(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):		
		self.users[pUserid] = [pConn, pAddr, pName, pIcon, pMaster, pRoomid]
		
	def keys(self):
		return self.users.keys()

	def has_key(self, userid):
		return self.users.has_key(userid)

	def remove(self, userid):
		write_log('ü Ʈ ')
		
		try:
			del self.users[userid]
		except:
			return
		
		return
		
	def set_roomid(self, userid, pValue):
		try:
			self.users[userid][self.ROOMID] = pValue
		except:
			write_log('AllUsersList.py -> set_roomid : error')
		
	def get_roomid(self, userid):
		try:
			roomid = self.users[userid][self.ROOMID]
		except:
			write_log('AllUsersList.py -> get_roomid : error')
		return roomid
		
	def get_name(self, userid):
		try:
			name = self.users[userid][self.NAME]
		except:
			write_log('AllUsersList.py -> get_name : error')
		return name

	def set_name(self, userid, name):
		if self.has_key(userid):
			self.users[userid][self.NAME] = name
		
	def get_icon(self, userid):
		try:
			icon = self.users[userid][self.ICON]
		except:
			write_log('AllUsersList.py -> get_icon : error')
		return icon
			
	def register(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):		

		try:
			if self.users.has_key(pUserid): 
				pConn.send("CLOSE" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + '̹ ϵ ̸Դϴ.\n')
				#pConn.close()
				return ''
				
			self.append(pConn, pAddr, int(pRoomid), pUserid, pName, pIcon, pMaster)
			return pUserid
		except:
			write_log('AllUsersList.py -> register : error')
		
	def	send_memo(self, pUserid, pName, pIcon, pMsg, pTo):
		try:
			if self.users.has_key(pTo):
				user = self.users[pTo]
				conn = user[self.CONN]
				conn.send('MEMO' + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + pMsg + '\n')
		except:
			write_log('AllUsersList.py -> send_memo : error')
			self.chatserver.user_disconnect(pTo, conn)
		
		
	def send_to(self, userid, name, icon, msg, to, fontcolor, backcolor, fontsize, fontname, fontbold, fontitalic, fontunderline):
		try:
			if self.users.has_key(userid):
				user = self.users[userid]
				conn = user[self.CONN]
				conn.send('MSG' + self.sep + userid + self.sep + name + self.sep + icon + self.sep + msg + self.sep + fontcolor + self.sep + backcolor + self.sep + fontsize + self.sep + fontname + self.sep + fontbold + self.sep + fontitalic + self.sep + fontunderline + '\n')
		except:
			write_log('AllUsersList.py -> send_to : error')
			self.chatserver.user_disconnect(userid, conn)
			return
			
		try:	
			if self.users.has_key(to):
				user = self.users[to]
				conn = user[self.CONN]
				conn.send('MSG' + self.sep + userid + self.sep + name + self.sep + icon + self.sep + msg + self.sep + fontcolor + self.sep + backcolor + self.sep + fontsize + self.sep + fontname + self.sep + fontbold + self.sep + fontitalic + self.sep + fontunderline + '\n')
		except:
			write_log('AllUsersList.py -> send_to : error')
			self.chatserver.user_disconnect(to, conn)
	
