#!/usr/bin/env python
# -*- coding: utf_8 -*-

import string
from GlobalVar import *


class RoomList:
	def __init__(self, pSep, pRoomsList):
		self.users	= {}
		self.sep	= pSep
		
		self.CONN	= 0
		self.ADDR	= 1
		self.NAME	= 2
		self.ICON	= 3
		self.MASTER	= 4
		
		self.NORMAL_VAR	= 0
		self.MASTER_VAR	= 1
		self.rooms	= pRoomsList
		
	def __len__(self):
		return len(self.users)

	def append(self, pConn, pAddr, pUserid, pName, pIcon, pMaster):		
		self.users[pUserid] = [pConn, pAddr, pName, pIcon, pMaster]
		write_log('Roomlist.py -> append : ߰ Ϸ')
		
	def keys(self):
		return self.users.keys()

	def has_key(self, userid):
		return self.users.has_key(userid)

	def remove(self, pUserid):
		user = self.users[pUserid]
		name = user[self.NAME]
		
		try:
			del self.users[pUserid]
			write_log('Roomlist.py -> remove :  ')
		except:
			write_log('Roomlist.py -> remove :   ')
			return
			
	def register(self, pConn, pAddr, pUserid, pName, pIcon, pMaster):		
		
		if self.users.has_key(pUserid): 
			pConn.send('admin'+ self.sep + 'black'+ self.sep +'̹ ϵ ̸Դϴ.\n')
			pConn.close()
			return ''
			
		self.append(pConn, pAddr, pUserid, pName, pIcon, pMaster)
		
	def joinroom(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):
		
		write_log('RoomList.py -> joinroom : ' + str(pRoomid))
		ret = self.rooms.users(pRoomid).register(pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster)
		
		if ret == '':
			pConn.send("JOINROOMINIT" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(pRoomid) + self.sep + self.rooms.get_roomname(pRoomid) + self.sep + str(pMaster) + '\n')
		else:
			pConn.send("JOINROOMINIT" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(pRoomid) + self.sep + self.rooms.get_roomname(pRoomid) + self.sep + str(pMaster) + '\n')
			
		# 濡  ǿ Ѵ
		self.remove(pUserid)
		self.send_all(pUserid, pName, pIcon, 'EXITWAITUSER', '')
	
	def send_all(self, pUserid, pName, pIcon, pCommand, pMsg):
		for user in self.users.values():
			conn = user[self.CONN]
			conn.send(pCommand + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + pMsg + '\n')
	
	def send_userlist(self, pConn, pUserid, pName, pIcon):
		
		try:
			result = "WAITUSER" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(len(self.users))
			for user in self.users.keys():
				userid		= user
				name		= self.users[user][self.NAME]
				icon		= self.users[user][self.ICON]
				master		= self.users[user][self.ICON]

				result = result + self.sep + userid + self.sep + name + self.sep + icon + self.sep + str(master)
				
			result = result + '\n'
			
			write_log('RoomList.py -> send_userlist : ' + result)
			
			pConn.send(result)
		except socket.error:
			write_log('RoomList.py -> send_userlist : Socket Error')
			
			