#!/usr/bin/env python
# -*- coding: utf_8 -*-

import string
import socket
from UsersList import *
from GlobalVar import *


class RoomsList:
	def __init__(self, pSep, pStaticRooms):
		self.rooms			= {}
		self.static_roomlen = 0
		self.roomlen		= int(pStaticRooms)
		self.sep			= pSep
		
		self.USERINFO		= 0
		self.ROOMINFO		= 1
		
		self.ROOMINFO_NAME	= 0
		self.ROOMINFO_LIMIT	= 1
		self.ROOMINFO_TYPE	= 2
		self.ROOMINFO_PASS	= 3
		self.ROOMINFO_GROUP	= 4
	
	def __len__(self):
		return len(self.rooms)

	def append(self, aaa, ddd):		
		self.rooms[aaa] = [ddd]
		
	def keys(self):
		return self.rooms.keys()

	def has_key(self, roomid):
		return self.rooms.has_key(roomid)

	def remove(self, roomid):
		try:
			del self.rooms[roomid]
		except:
			return	
			
	def get_roomlen(self):
		return self.roomlen
		
	def static_register(self, pRoomname, pRoomlimit, pRoomtype, pRoompass, pRoomgroup):
		self.static_roomlen = self.static_roomlen + 1
		roomid = self.static_roomlen
		self.rooms[roomid] = (UsersList(self.sep), [pRoomname, pRoomlimit, pRoomtype, pRoompass, pRoomgroup])
		return roomid
		
	def register(self, pRoomname, pRoomlimit, pRoomtype, pRoompass, pRoomgroup):
		self.roomlen = self.roomlen + 1
		roomid = self.roomlen
		self.rooms[roomid] = (UsersList(self.sep), [pRoomname, pRoomlimit, pRoomtype, pRoompass, pRoomgroup])
		
		write_log('RoomsList.py -> register :  ' + str(roomid))
		return roomid
		
	def get_roomlimit(self, pRoomid):
		return self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_LIMIT]
		
	def get_roompass(self, pRoomid):
		return self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_PASS]
		
	def get_roomname(self, pRoomid):
		return self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_NAME]
		
	def set_roomlimit(self, pRoomid, pValue):
		self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_LIMIT] = pValue
		
	def set_roompass(self, pRoomid, pValue):
		self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_PASS] = pValue
		
	def set_roomname(self, pRoomid, pValue):
		self.rooms[pRoomid][self.ROOMINFO][self.ROOMINFO_NAME] = pValue
		
	def users(self, pRoomid):
		return self.rooms[pRoomid][self.USERINFO]
		
	def send_roomlist(self, conn):
		try:
			conn.send(str(len(self.rooms)));
			for roomid in self.rooms.keys():
				roomlimit	= str(self.get_roomlimit(roomid))
				roompass	= self.get_roompass(roomid)
				roomname	= self.get_roomname(roomid)
				roomusercount		= str(len(self.users(roomid)))
				conn.send(self.sep + roomid + self.sep + roomname + self.sep + roomlimit + self.sep + roompass + self.sep + roomusercount)
			conn.send('\n');
		except socket.error:
			write_log('RoomsList.py -> send_roomlist -> send : Socket error')
		
		try:
			conn.close()
		except socket.error:
			write_log('RoomsList.py -> send_roomlist -> close : Socket error')
			
	def send_roominfo(self, conn, roomid):	
		try:
			roomlimit			= str(self.get_roomlimit(roomid))
			roompass			= self.get_roompass(roomid)
			roomname			= self.get_roomname(roomid)
			roomusercount		= str(len(self.users(roomid)))
			conn.send(roomid + self.sep + roomname + self.sep + roomlimit + self.sep + roompass + self.sep + roomusercount)
			conn.send('\n');
		except socket.error:
			write_log('RoomsList.py -> send_roominfo -> send : Socket error')
			
		try:
			conn.close()
		except socket.error:
			write_log('RoomsList.py -> send_roominfo -> close : Socket error')

	def send_roompass(self, conn, roomid, roompass):
		try:		
			realpass = self.get_roompass(roomid)
			if roompass == realpass:
				conn.send("OK")
			else:
				conn.send("NO")
			conn.send('\n')
		except socket.error:
			write_log('RoomsList.py -> send_roompass -> send : Socket error')
			
		try:
			conn.close()
		except socket.error:
			write_log('RoomsList.py -> send_roompass -> close : Socket error')
			
	def check_login(self, pUserid):
		for roomid in self.rooms.keys():
			users = self.users(roomid)
			for userid in users.keys():
				if pUserid == userid:
					return 0
					
		return 1
		
	def check_roomname(self, pRoomname):
		for roomid in self.rooms.keys():
			if self.get_roomname(roomid) == pRoomname:
				return 'NO'
					
		return 'OK'
		
	def mastermenu(self, pRoomid, pUserid, pRoomlimit, pRoompass, pRoomname, pOldroomname, pGoout, pChangemaster, pNamecheck):
		if pNamecheck == '1':
			for roomid in self.rooms.keys():
				if roomid != pRoomid and self.get_roomname(roomid) == pRoomname:
					return 'NO'
				
		self.set_roomlimit(pRoomid, pRoomlimit)
		self.set_roompass(pRoomid, pRoompass)
		
		users = self.users(pRoomid)
		
		if pRoomname != pOldroomname:
			self.set_roomname(pRoomid, pRoomname)
			users.send_changetitle(pRoomname)
			
		if pGoout != '':
			users.send_force(pGoout, pUserid)
				
		if pChangemaster != '':
			users.send_master(pChangemaster, pUserid)
				
		return 'OK'
		
	def send_roomname(self, conn, result):
		try:		
			conn.send(result)
			conn.send('\n')
		except socket.error:
			write_log('RoomsList.py -> send_roomname -> send : Socket error')
			
		try:
			conn.close()
		except socket.error:
			write_log('RoomsList.py -> send_roomname -> close : Socket error')
		
	def send_logincheck(self, conn, userid):
		conn.send('logincheck' + self.sep + userid + self.sep + '1' + '\n')
		
	def send_notroom(self, conn, roomid):
		conn.send('notroom' + self.sep + roomid + self.sep + '1' + '\n')
	