#!/usr/bin/env python
# -*- coding: utf_8 -*-

import string
import socket
from GlobalVar import *
from ChatServer import *

class UsersList:
	def __init__(self, pSep, pChatServer):
		self.users			= {}
		self.chatserver		= pChatServer
		self.sep			= pSep
		
		self.CONN			= 0
		self.ADDR			= 1
		self.NAME			= 2
		self.ICON			= 3
		self.MASTER			= 4
		self.ROOMID			= 5
		
		self.NORMAL_VAR		= 0
		self.MASTER_VAR		= 1
		
	def __len__(self):
		return len(self.users)

	def append(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):		
		self.users[pUserid] = [pConn, pAddr, pName, pIcon, pMaster, pRoomid]
		
	def keys(self):
		return self.users.keys()

	def has_key(self, userid):
		return self.users.has_key(userid)

	def remove(self, userid):
		
		try:
			del self.users[userid]
		except:
			return
		
		return
			
		self.send_exit(userid, name)
			
		#    ٸ   üѴ
		if temp[self.MASTER] == self.MASTER_VAR:
			if len(self.users) > 0:
				for touserid in self.users.keys():
					user = self.users[touserid]
					user[self.MASTER] = self.MASTER_VAR
					conn = user[self.CONN]
					conn.send('gotmaster' + self.sep + userid + self.sep + touserid + '\n')
					
					break
		
	def register(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):		

		write_log('UserList.py -> register :  ')
		
		if self.users.has_key(pUserid): 
			#pConn.send('admin'+ self.sep + 'black'+ self.sep +'̹ ϵ ̸Դϴ.\n')
			#pConn.close()
			return ''
			
		#self.send_join(pName, pUserid, pIcon)
		self.append(pConn, pAddr, int(pRoomid), pUserid, pName, pIcon, pMaster)
		return pUserid
	
	def send_changename(self, pUserid, pOldName, pOldIcon, pName, pIcon):		
		
		self.users[pUserid][self.NAME] = pName
		self.users[pUserid][self.ICON] = pIcon		
				
		for user in self.users.values():
			conn = user[self.CONN]
			conn.send('changename' + self.sep + pOldName + self.sep + pOldIcon + self.sep + pName + self.sep + pIcon + '\n')
	
	def send_music(self, pName, pIcon, pInfo):
		for user in self.users.values():
			conn = user[self.CONN]
			conn.send('music' + self.sep + pName + self.sep + pIcon + self.sep + pInfo + '\n')
				
	def send_changetitle(self, pTitle):		
		for username in self.users.keys():
			user = self.users[username]
			conn = user[self.CONN]
			conn.send('changetitle' + self.sep + pTitle + self.sep + pTitle + '\n')
						
	def send_force(self, pToid, pFromid):				
		for userid in self.users.keys():			
			if userid == pToid:
				user = self.users[userid]
				conn = user[self.CONN]				
				conn.send('force' + self.sep + pFromid + self.sep + pToid + '\n')
				break
	
	def send_master(self, pToid, pFromid):				
		for userid in self.users.keys():			
			if userid == pToid:
				user = self.users[userid]
				conn = user[self.CONN]				
				conn.send('gotmaster' + self.sep + pFromid + self.sep + pToid + '\n')
			
			elif userid == pFromid:
				user = self.users[userid]
				conn = user[self.CONN]				
				conn.send('lostmaster' + self.sep + pFromid + self.sep + pToid + '\n')
				
			else:
				user = self.users[userid]
				conn = user[self.CONN]				
				conn.send('changemaster' + self.sep + self.users[pToid][self.NAME] + self.sep + self.users[pToid][self.ICON] + '\n')
	
	def send_list(self, fromname, fromid, icon):
		strTemp = str(len(self.users))
		
		for userid in self.users.keys():
			user = self.users[userid]
			
			name = user[self.NAME]
			icon = user[self.ICON]
			strTemp = strTemp + self.sep + userid + self.sep + name + self.sep + icon
		conn = self.users[fromid][self.CONN]
		conn.send('list' + self.sep + fromname + self.sep + strTemp + "\n")
			
	def send_join(self, name, userid, icon):
		for user in self.users.values():
			conn = user[self.CONN]
			conn.send('joinuser' + self.sep + name + self.sep + icon + '\n')	
			
	def send_roomid(self, userid, roomid, roomname):
		user = self.users[userid]
		conn = user[self.CONN]
		conn.send('roomid' + self.sep + userid + self.sep + str(roomid) + self.sep + roomname + self.sep + str(user[self.MASTER]) + '\n')
			
	def set_master(self, userid, pValue):
		self.users[userid][self.MASTER] = pValue
		
	def get_master(self, userid):
		return self.users[userid][self.MASTER]
		
	def set_roomid(self, userid, pValue):
		self.users[userid][self.ROOMID] = pValue
		
	def get_roomid(self, userid):
		return self.users[userid][self.ROOMID]
		
	def send_msg(self, userid, name, icon, msg, fontcolor, backcolor, fontsize, fontname, fontbold, fontitalic, fontunderline):
		for user in self.users.values():
			conn = user[self.CONN]
			try:
				conn.send('MSG' + self.sep + userid + self.sep + name + self.sep + icon + self.sep + msg + self.sep + fontcolor + self.sep + backcolor + self.sep + fontsize + self.sep + fontname + self.sep + fontbold + self.sep + fontitalic + self.sep + fontunderline + '\n')
			except socket.error:
				write_log('UsersList.py -> send_msg : Socket Error')
				self.chatserver.user_disconnect(userid, conn)
		
	def send_tomsg(self, userid, name, icon, msg, to, fontcolor, backcolor, fontsize, fontname, fontbold, fontitalic, fontunderline):
		if not self.has_key(userid):
			return
			
		if not self.has_key(to):
			return
			
		user = self.users[userid]
		conn = user[self.CONN]
		
		try:
			conn.send('MSG' + self.sep + userid + self.sep + name + self.sep + icon + self.sep + msg + self.sep + fontcolor + self.sep + backcolor + self.sep + fontsize + self.sep + fontname + self.sep + fontbold + self.sep + fontitalic + self.sep + fontunderline + '\n')
		except socket.error:
			write_log('UsersList.py -> send_tomsg -> ڽ : Socket Error')
			self.chatserver.user_disconnect(userid, conn)
			
			return
			
		user = self.users[to]
		conn = user[self.CONN]
		
		try:
			conn.send('MSG' + self.sep + userid + self.sep + name + self.sep + icon + self.sep + msg + self.sep + fontcolor + self.sep + backcolor + self.sep + fontsize + self.sep + fontname + self.sep + fontbold + self.sep + fontitalic + self.sep + fontunderline + '\n')
		except socket.error:
			write_log('UsersList.py -> send_tomsg ->   : Socket Error')
			self.chatserver.user_disconnect(userid, conn)
	
	def send_to(self, pUserid, pName, pIcon, pCommand, pMsg, pToid):
		if not self.has_key(pToid):
			return
			
		try:
			user = self.users[pToid]
			conn = user[self.CONN]
			conn.send(pCommand + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + pMsg + '\n')
		except socket.error:
			write_log('UsersList.py -> send_to : Socket Error')
			self.chatserver.user_disconnect(pToid, conn)
				
	def send_all(self, pUserid, pName, pIcon, pCommand, pMsg):
		write_log('UserList.py -> send_all : ' +  str(len(self.users)) + '')
		for userid in self.users.keys():
			try:
				user = self.users[userid]
				conn = user[self.CONN]
				conn.send(pCommand + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + pMsg + '\n')
			except socket.error:
				write_log('UsersList.py -> send_all : Socket Error')
				self.chatserver.user_disconnect(userid, conn)
			
	def send_userlist(self, pConn, pUserid, pName, pIcon):
		try:
			result = "USER" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(len(self.users))
			for user in self.users.keys():
				userid		= user
				name		= self.users[user][self.NAME]
				icon		= self.users[user][self.ICON]
				master		= self.users[user][self.MASTER]

				result = result + self.sep + userid + self.sep + name + self.sep + icon + self.sep + str(master)
				
			result = result + '\n'
			
			write_log('UsersList.py -> send_userlist :')
			
			try:
				pConn.send(result)
			except socket.error:
				write_log('UsersList.py -> send_userlist : Socket Error')
				self.chatserver.user_disconnect(pUserid, pConn)
		except socket.error:
			write_log('UsersList.py -> send_userlist : Socket Error')
			self.chatserver.user_disconnect(pUserid, pConn)
	
	
		
