#!/usr/bin/env python
# -*- coding: utf_8 -*-

import string
from Room import *
from AllUsersList import *
from GlobalVar import *
from ChatServer import *

class WaitRoom:
	def __init__(self, pSep, pChatServer):
		self.users	= {}

		self.sep	= pSep
		
		self.CONN	= 0
		self.ADDR	= 1
		self.NAME	= 2
		self.ICON	= 3
		self.MASTER	= 4
		
		self.NORMAL_VAR	= 0
		self.MASTER_VAR	= 1
		
		self.chatserver		= pChatServer
		self.allusers		= self.chatserver.allusers
		self.rooms			= self.chatserver.rooms
		
		
	def __len__(self):
		return len(self.users)

	def append(self, pConn, pAddr, pUserid, pName, pIcon, pMaster):		
		self.users[pUserid] = [pConn, pAddr, pName, pIcon, pMaster]
		write_log('WaitRoom.py -> append : ߰ Ϸ')
		
	def keys(self):
		return self.users.keys()

	def has_key(self, userid):
		return self.users.has_key(userid)

	def remove(self, pUserid):
		try:
			write_log('WaitRoom.py -> remove :   õ')
			del self.users[pUserid]
			write_log('WaitRoom.py -> remove :  ')
		except:
			return
			
	def register(self, pConn, pAddr, pUserid, pName, pIcon, pMaster):		
		
		write_log('WaitRoom.py -> register : ߺ üũ')
		if self.users.has_key(pUserid):
			pConn.send('admin'+ self.sep + 'black'+ self.sep +'̹ ϵ ̸Դϴ.\n')
			pConn.close()
			return ''
			
		self.append(pConn, pAddr, pUserid, pName, pIcon, pMaster)
		
	def connect(self, pConn, pAddr, userid, name, icon):
		write_log('WaitRoom.py -> connect : ο  ')
		self.send_all(userid, name, icon, 'JOINWAITUSER', '')
		write_log('WaitRoom.py -> connect : ڸ Ѵ')
		self.register(pConn, pAddr, userid, name, icon, self.NORMAL_VAR) 
		self.allusers.set_roomid(userid, '0')
		
		#    
		self.send_roomlist(pConn, userid, name, icon)
		
		#    
		self.send_userlist(pConn, userid, name, icon)
		
		return 0
		
	def disconnect(self, pConn, pAddr, userid, name, icon):
		self.remove(userid)
		self.send_all(userid, name, icon, 'EXITWAITUSER', '')
		
		# üƮ 
		self.allusers.remove(userid)
		
		return -2
		
	def start(self, pConn, pAddr, userid, name, icon):
		write_log('WaitRoom.py -> start : üƮ Ѵ')
		if not self.allusers.register(pConn, pAddr, '0', userid, name, icon, self.NORMAL_VAR):
			return -2
		
		# Ʒ   CONNECT ؿ
		write_log('WaitRoom.py -> start : ο  ')
		self.send_all(userid, name, icon, 'JOINWAITUSER', '')
		write_log('WaitRoom.py -> start : ڸ Ѵ')
		self.register(pConn, pAddr, userid, name, icon, self.NORMAL_VAR) 
		self.allusers.set_roomid(userid, '0')
		
		#    
		self.send_roomlist(pConn, userid, name, icon)
		
		#    
		self.send_userlist(pConn, userid, name, icon)
		
		result = 0
		
		return result
		
	def makeroom(self, pConn, pAddr, roomid, userid, name, icon, roomname, roomlimit, roomtype, roompass, roomgroup):
		
		roomid = self.rooms.register(roomname, roomlimit, roomtype, roompass, roomgroup)
		
		self.do_joinroom(pConn, pAddr, roomid, userid, name, icon, self.MASTER_VAR)
		self.allusers.set_roomid(userid, roomid)
		
		#   ̿ ̸ ˸
		self.send_all('#', '#', '#', 'MAKEROOM', '')
		
		#   ID Ѵ
		result = roomid
		
		return result
		
	def joinroom(self,  pConn, pAddr, command, userid, name, icon, roomid):
			
		if self.rooms.get_roomtype(roomid) == '1':
			
			if int(self.rooms.get_roomlimit(roomid)) > len(self.rooms.users(roomid)):
				self.do_joinroom(pConn, pAddr, roomid, userid, name, icon, self.NORMAL_VAR)
				self.allusers.set_roomid(userid, roomid)
				#   ID Ѵ
				
				# 濡 ڰ  ̿ ̸ ˸ (  ٲ .)
				self.send_all('#', '#', '#', 'JOINROOM', '')
				
				result = roomid
				
				return result
			else:
				pConn.send("ALERT" + self.sep + userid + self.sep + name + self.sep + icon + self.sep + 'ο  áϴ' + '\n')
				write_log('WaitRoom.py -> joinroom :   á')
				
		return 0
		
	def joinsecretroom(self,  pConn, pAddr, command, userid, name, icon, roomid, passwd):
		if self.rooms.get_roomtype(roomid) == '2':
			if int(self.rooms.get_roomlimit(roomid)) > len(self.rooms.users(roomid)):
				if self.rooms.get_roompass(roomid) == passwd:
					self.do_joinroom(pConn, pAddr, roomid, userid, name, icon, self.NORMAL_VAR)
					self.allusers.set_roomid(userid, roomid)
					#   ID Ѵ
					
					# 濡 ڰ  ̿ ̸ ˸ (  ٲ .)
					self.send_all('#', '#', '#', 'JOINROOM', '')
					
					result = roomid
					
					return result
					
				else:
					pConn.send("ALERT" + self.sep + userid + self.sep + name + self.sep + icon + self.sep + 'йȣ Ȯ ʽϴ' + '\n')
			else:
				pConn.send("ALERT" + self.sep + userid + self.sep + name + self.sep + icon + self.sep + 'ο  áϴ' + '\n')
				write_log('WaitRoom.py -> joinsecretroom :   á')
			
		return 0
		
	def send_removeroom(self, pRoomid):
		write_log('WaitRoom.py -> send_removeroom :   ˸')
		#   ̿ ̸ ˸
		self.send_all('#', '#', '#', 'REMOVEROOM', '')
		
	def do_joinroom(self, pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster):
		
		write_log('WaitRoom.py -> do_joinroom :   ' + str(pRoomid))
		ret = self.rooms.users(pRoomid).register(pConn, pAddr, pRoomid, pUserid, pName, pIcon, pMaster)
		
		if ret == '':
			pConn.send("JOINROOMINIT" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(pRoomid) + self.sep + self.rooms.get_roomname(pRoomid) + self.sep + str(pMaster) + '\n')
		else:
			pConn.send("JOINROOMINIT" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(pRoomid) + self.sep + self.rooms.get_roomname(pRoomid) + self.sep + str(pMaster) + '\n')
			
		# 濡  ǿ Ѵ
		self.remove(pUserid)
		self.send_all(pUserid, pName, pIcon, 'EXITWAITUSER', '')
	
	def send_all(self, pUserid, pName, pIcon, pCommand, pMsg):
		write_log('send_all ')
		for user in self.users.values():
			conn = user[self.CONN]
			
			result = pCommand + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + pMsg + '\n'
			
			try:
				conn.send(result)
			except socket.error:
				write_log('WaitRoom.py -> send_all : Socket Error - ' + pUserid)
				self.remove(pUserid)
				#self.send_all(pUserid, pName, pIcon, 'EXITWAITUSER', '')
				
				# üƮ 
				self.allusers.remove(pUserid)
				
				self.chatserver.removesocket(conn)
		return 0
			
	def send_userlist(self, pConn, pUserid, pName, pIcon):
		
		try:
			result = "WAITUSER" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(len(self.users))
			for user in self.users.keys():
				userid		= user
				name		= self.users[user][self.NAME]
				icon		= self.users[user][self.ICON]
				master		= '0'

				result = result + self.sep + userid + self.sep + name + self.sep + icon + self.sep + str(master)
				
			result = result + '\n'
			
			write_log('WaitRoom.py -> send_userlist')
			
			pConn.send(result)
		except socket.error:
			write_log('WaitRoom.py -> send_userlist : Socket Error')	
			self.remove(pUserid)
			#self.send_all(pUserid, pName, pIcon, 'EXITWAITUSER', '')
			
			# üƮ 
			self.allusers.remove(pUserid)
			
			self.chatserver.removesocket(pConn)
			
	def send_roomlist(self, pConn, pUserid, pName, pIcon):
		
		try:
			result = "ROOMLIST" + self.sep + pUserid + self.sep + pName + self.sep + pIcon + self.sep + str(len(self.rooms))
			for room in self.rooms.keys():
				roomname		= self.rooms.get_roomname(room)
				roomlimit		= self.rooms.get_roomlimit(room)
				roomtype		= self.rooms.get_roomtype(room)
				roompass		= self.rooms.get_roompass(room)
				roomgroup		= self.rooms.get_roomgroup(room)
				roomusersize	= self.rooms.get_roomusersize(room)
				
				if roompass == '':
					roompass = 'null'

				result = result + self.sep + str(room) + self.sep + roomname + self.sep + str(roomlimit) + self.sep + str(roomtype) + self.sep + str(roompass) + self.sep + str(roomgroup) + self.sep + str(roomusersize)
				
			result = result + '\n'
			
			write_log('WaitRoom.py -> send_roomlist')
			
			pConn.send(result)
		except socket.error:
			write_log('WaitRoom.py -> send_roomlist : Socket Error')	
			self.remove(pUserid)
			#self.send_all(pUserid, pName, pIcon, 'EXITWAITUSER', '')
			
			# üƮ 
			self.allusers.remove(pUserid)
			
			self.chatserver.removesocket(pConn)
			
		return 0
		